﻿Imports System.Data.OleDb
Imports CrystalDecisions.CrystalReports.Engine
Imports CrystalDecisions.Windows.Forms

Module Config
    Private ConnectionString As String = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" & Application.StartupPath & "\PrintLoggingSystem.accdb"

    Private DbConnection As OleDbConnection
    Private DbDataApapter As OleDbDataAdapter
    Private DbCommand As OleDbCommand
    Private DbDataSet As DataSet
    Private DbDataTable As DataTable


    Public DbReader As OleDbDataReader
    Public Const APP_NAME = "Print Logging System"


    Private Sub SetDbConnection()
        Try
            DbConnection = New OleDbConnection(ConnectionString)
            If DbConnection.State = ConnectionState.Open Then DbConnection.Close()
            DbConnection.Open()

        Catch ex As Exception
            MessageBox.Show(ex.Message, "", MessageBoxButtons.OK, MessageBoxIcon.Warning)
        End Try

    End Sub

    Public Sub DbQuery(Query As String)
        DbDataTable = New DataTable

        Try
            SetDbConnection()
            DbDataApapter = New OleDbDataAdapter(Query, DbConnection)
            DbDataApapter.Fill(DbDataTable)

        Catch ex As Exception
            MessageBox.Show(ex.Message, APP_NAME, MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try

    End Sub

    Public Sub DbQuery(Query As String, ResultDataGridView As DataGridView, Message As String)
        DbDataTable = New DataTable

        Try
            SetDbConnection()
            If Query.Contains("SELECT") Then
                DbDataApapter = New OleDbDataAdapter(Query, DbConnection)
                DbDataApapter.Fill(DbDataTable)

                ResultDataGridView.DataSource = DbDataTable
                If ResultDataGridView.Columns.Contains("ID") Then
                    ResultDataGridView.Columns("ID").Visible = False
                End If
            Else
                DbDataApapter = New OleDbDataAdapter(Query, DbConnection)
                DbDataApapter.Fill(DbDataTable)

                MessageBox.Show(Message, APP_NAME, MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, APP_NAME, MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try

    End Sub

    Public Sub DbQuery(Query As String, ResultDataGridView As DataGridView)
        DbDataTable = New DataTable

        Try
            SetDbConnection()
            If Query.Contains("SELECT") Then
                DbDataApapter = New OleDbDataAdapter(Query, DbConnection)
                DbDataApapter.Fill(DbDataTable)

                ResultDataGridView.DataSource = DbDataTable
                If ResultDataGridView.Columns.Contains("ID") Then
                    ResultDataGridView.Columns("ID").Visible = False
                End If
            Else
                DbDataApapter = New OleDbDataAdapter(Query, DbConnection)
                DbDataApapter.Fill(DbDataTable)
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, APP_NAME, MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try

    End Sub

    Public Sub ClearAllInputFields(TargetForm As Control)
        For Each child As Control In TargetForm.Controls
            ClearAllInputFields(child)
        Next

        If TryCast(TargetForm, TextBox) IsNot Nothing Then
            TryCast(TargetForm, TextBox).Text = String.Empty
        ElseIf TryCast(TargetForm, ComboBox) IsNot Nothing Then
            TryCast(TargetForm, ComboBox).Text = String.Empty
        End If

    End Sub

    Public Sub PrintReport(SqlQuery As String, ReportFile As String, ReportDocumentViewer As CrystalReportViewer)
        Dim ReportPath As String = ""
        Dim ReportDocument As ReportDocument = New ReportDocument

        Try
            DbDataSet = New DataSet
            DbCommand = New OleDbCommand(SqlQuery, DbConnection)
            DbDataApapter.Fill(DbDataSet)

            ReportPath = Application.StartupPath & "\" & ReportFile & ".rpt"

            If IO.File.Exists(ReportPath) Then
                If SqlQuery.Contains("SELECT") Then
                    ReportDocument.Load(ReportPath)
                    ReportDocument.SetDataSource(DbDataSet.Tables("Logs"))
                    ReportDocumentViewer.ReportSource = ReportDocument
                Else
                    MessageBox.Show("SELECT query is only allowed!", APP_NAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)
                End If
            Else
                MessageBox.Show("File not found!" & vbCrLf & "Please check the file name of the report and try again.", APP_NAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message, APP_NAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)
        End Try

    End Sub
End Module
